package ru.ulstu.fc.project.service;

import org.springframework.stereotype.Service;
import ru.ulstu.fc.project.model.Project;
import ru.ulstu.fc.project.model.ProjectForm;
import ru.ulstu.fc.project.repository.ProjectRepository;

import java.util.List;

@Service
public class ProjectService {
    private final ProjectRepository projectRepository;

    public ProjectService(ProjectRepository projectRepository) {
        this.projectRepository = projectRepository;
    }

    public List<Project> getCurrentUserProjects() {
        return projectRepository.findAll();
    }

    public Project save(ProjectForm projectForm) {
        if (projectForm.getId() == null) {
            return projectRepository.save(new Project(projectForm));
        }
        Project project = projectRepository
                .findById(projectForm.getId())
                .orElseThrow(() -> new RuntimeException("Project not found by id"));
        project.setName(projectForm.getName());
        return projectRepository.save(project);
    }

    public void delete(ProjectForm projectForm) {
        projectRepository.deleteById(projectForm.getId());
    }
}
